<?php

namespace Magento\FirstDataGateway\Controller\Helper;

class Total extends \Magento\Framework\App\Action\Action
{
	protected $_pageFactory;
	protected $scopeConfig;
	protected $quoteFactory;

	public function __construct(
		\Magento\Framework\App\Action\Context $context,
		\Magento\Framework\View\Result\PageFactory $pageFactory,
		\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
		\Magento\Quote\Model\QuoteFactory $quoteFactory
	)
	{
		$this->_pageFactory = $pageFactory;
		$this->scopeConfig = $scopeConfig;
		$this->quoteFactory = $quoteFactory;
		return parent::__construct($context);
	}

	public function execute()
	{
		$json = json_decode(file_get_contents('php://input'), true);
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
		$base = $storeManager->getStore()->getBaseUrl();
		$curr = $json['currency'] == 'PLN' ? '985' : '0';
		$lang = $storeManager->getStore()->getLocaleCode();
		if(!in_array($lang, array('pl_PL', 'en_US'))) $lang = 'en_US';
		$orderCol = $objectManager->create('Magento\Sales\Model\Order')->getCollection()->addAttributeToFilter('quote_id', $json['oid'])->load();
		if($orderCol->getTotalCount() != 1) $ret = array('error' => 'Bad quote id: ' . $json['order_id']);
		else {
			foreach($orderCol as $o) $order = $o;
//			$timezone = $this->scopeConfig->getValue('general/locale/timezone', \Magento\Store\Model\ScopeInterface::SCOPE_STORE, $order->getStoreId());
			$timezone = 'UTC';
			if(!$order) $ret = array('error' => 'Invalid quote id: ' . $json['oid']);
			elseif($order->getCustomerEmail() != $json['email']) $ret = array('error' => 'Invalid email');
			elseif($order->getBaseSubtotal() != $json['chargetotal']) $ret = array('error' => 'Invalid total');
			else $ret = array(
			    'chargetotal' => $order->getBaseGrandTotal(),
			    'oid' => $order->getIncrementId(),
			    'sess' => md5('' . $order->getIncrementId() . $this->scopeConfig->getValue('payment/firstdata_gateway/key')),
			    'responseFailURL' => $base . 'firstdata/update/error',
			    'responseSuccessURL' => $base . 'firstdata/update/success',
			    'transactionNotificationURL' => $base . 'firstdata/update/update',
			    'currency' => $curr,
			    'txndatetime' => date("Y:m:d-H:i:s"),
			    'timezone' => $timezone,
			    'language' => $lang
			);
		}

		$this->getResponse()->setHeader('Content-type', 'application/json');
		$this->getResponse()->setBody(json_encode($ret));
		$this->getResponse()->sendResponse();
		exit;
	}

}
