
define(
    [
    	'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Paypal/js/action/set-payment-method',
        'Magento_Customer/js/model/customer',
        'Magento_Customer/js/customer-data',
        'Magento_Checkout/js/model/quote'
    ],
    function ($, Component, setPaymentMethodAction, customer, customerData, quote) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'Magento_FirstDataGateway/payment/form',
                transactionResult: '',
                redirectAfterPlaceOrder: false
            },

            getCode: function() {
                return 'firstdata_gateway';
            },

            getLogo: function () {
                return window.checkoutConfig.payment.firstdata_gateway.logo;
            },

            afterPlaceOrder: function() {
       			var location = window.checkoutConfig.payment.firstdata_gateway.gateway;
       			var bd = quote.billingAddress();
       			var mail = null;
       			if(!customer.isLoggedIn()) mail = quote.guestEmail;
       			else mail = window.checkoutConfig.customerData.email;
       			var d = {
       				storename: window.checkoutConfig.payment.firstdata_gateway.pos_id,
                    oid: window.checkoutConfig.payment.firstdata_gateway.id,
       				chargetotal: window.checkoutConfig.quoteData.base_subtotal,
       				currency: window.checkoutConfig.quoteData.base_currency_code,
       				language: '',
       				checkoutoption: 'combinedpage',
       				hash_algorithm: 'HMACSHA256',
       				bcountry: bd.countryId,
       				bzip: bd.postcode,
       				bcity: bd.city,
       				email: mail.substring(0, 40),
       				//ba_firstname: bd.firstname,
       				//ba_lastname: bd.lastname,
       				responseFailURL: '',
       				responseSuccessURL: '',
       				timezone: '',
       				transactionNotificationURL: '',
                    txndatetime: '',
                    txntype: 'sale'
       			};
       			var jtotal = $.ajax({
       				type: "POST",
       				dataType: "json",
       		        url: '../firstdata/helper/total',
       		        contentType: "application/json; charset=utf-8",
       		        data: JSON.stringify(d),
       		        async: false
       		    }).responseText;
       			var total = JSON.parse(jtotal);
       			d['chargetotal'] = '' + Math.round(total.chargetotal * 100) / 100;
                d['currency'] = total.currency;
       			d['oid'] = total.oid;
       			d['hashExtended'] = total.sess;
       			d['responseFailURL'] = total.responseFailURL;
                d['responseSuccessURL'] = total.responseSuccessURL;
                d['transactionNotificationURL'] = total.transactionNotificationURL;
                d['txndatetime'] = total.txndatetime;
                d['timezone'] = total.timezone;
                d['language'] = total.language;
       			var jcdata = $.ajax({
       				type: "POST",
       				dataType: "json",
       		        url: '../firstdata/helper/cdata',
       		        contentType: "application/json; charset=utf-8",
       		        data: JSON.stringify(d),
       		        async: false
       		    }).responseText;
       			var cdata = JSON.parse(jcdata);
       			d['hashExtended'] = cdata.hashExtended;
    			var form = '';
    			$.each(d, function(key, value) {
    	            if(value) value = value.split('"').join('\"')
    	            form += '<input type="hidden" name="'+key+'" value="'+value+'">';
    	        });
    	        $('<form action="' + location + '" method="POST">' + form + '</form>').appendTo($(document.body)).submit();
            }
        });
    }
);
